// (C) 2001 SyGem Software

import java.awt.*;
import java.applet.*;

import com.sygem.jazz3d3.*;
import com.sygem.jazz3d3.primitive.Cube3d;

public class modifyVertices extends Applet implements Runnable {

        Thread m_ce;
        World myWorld;
        int light1;
        int pid;

		boolean antialias = false;

		boolean zoomIn = true;
		double pos = -0.5;

        //Construct the applet
        public modifyVertices() {
        }

        //Initialize the applet
        public void init() {

			myWorld = new World(this);
			setLayout(new BorderLayout());
			add("Center",myWorld);
			myWorld.setDelay(1);

			RenderSolid rSolid = new RenderSolid();
			rSolid.setDrawingMode(Render.FLAT);

			Cube3d sp1 = new Cube3d(0,0,8);
			sp1.rotateLocal(-55,0,0);
			sp1.setColour(255,0,0);
			sp1.setRenderer(rSolid);
			pid = myWorld.addObject(sp1);

			Light l1 = new Light(0,0,1);
			myWorld.addLight(l1);

        }

        //Start the applet
        public void start() {
			if (m_ce == null) {
				m_ce = new Thread(this);
				m_ce.start();
			}
        }

        //Stop the applet
        public void stop() {
			if (m_ce != null) {
				m_ce.stop();
				m_ce = null;
			}
        }

        //Destroy the applet
        public void destroy() {
        }

        public void run() {
			int iCount = 0;
			long lTime0 = System.currentTimeMillis();
			myWorld.prep();
			m_ce.setPriority(Thread.MAX_PRIORITY);
			Object3d myObject;
			Vertex tVertex;
			double posx,posy,posz;

			while (true) {

				myObject = myWorld.getParentObject(pid);

				if (zoomIn) {
					pos += 0.01;
					if (pos > -0.1) zoomIn = false;
				} else {
					pos -= 0.01;
					if (pos < -0.6) zoomIn = true;
				}

				tVertex = myObject.getVertex(0);
				tVertex.setX(pos);
				tVertex.setY(pos);

				tVertex = myObject.getVertex(1);
				tVertex.setX(-pos);
				tVertex.setY(pos);

				tVertex = myObject.getVertex(2);
				tVertex.setX(-pos);
				tVertex.setY(-pos);

				tVertex = myObject.getVertex(3);
				tVertex.setX(pos);
				tVertex.setY(-pos);

				myWorld.redraw();
			}
        }

		public boolean keyDown(Event evt,int key) {

			if ((char)key=='a') {antialias=!antialias; myWorld.setAntiAliasing(antialias); return true; }

			return true;
		}
}