// (C) 2001 SyGem Software

import java.awt.*;
import java.applet.*;

import com.sygem.jazz3d3.*;
import com.sygem.jazz3d3.primitive.Cube3d;

public class panback extends Applet implements Runnable {
        Thread m_ce;
        World myWorld;
        int light1;
        int pid;
        int myx,myy,oldx,oldy=0;

        //Construct the applet
        public panback() {
        }

        //Initialize the applet
        public void init() {

                myWorld = new World(this);
                setLayout(new BorderLayout());
                add("Center",myWorld);

				Texture t1 = TextureLoader.loadImage("images/earth.jpg");
                myWorld.setPanoramicBackground(t1);

                RenderSolid tex = new RenderSolid();
                Cube3d sp1 = new Cube3d(0,0,8);
                sp1.setRenderer(tex);
                pid = myWorld.addObject(sp1);

                Light l1 = new Light(0,0,1);
                myWorld.addLight(l1);

        }

        //Start the applet
        public void start() {
                if (m_ce == null) {
                        m_ce = new Thread(this);
                        m_ce.start();
                }
        }

        //Stop the applet
        public void stop() {
                if (m_ce != null) {
                        m_ce.stop();
                        m_ce = null;
                }
        }

        //Destroy the applet
        public void destroy() {
        }

        public void run() {
                int iCount = 0;
                long lTime0 = System.currentTimeMillis();
                double x,y,z;
                x = 0.16;
                y = 0.35;
                z = 0.21;
                myWorld.prep();

                int xx=0;

                while (true) {

                        myWorld.getParentObject(pid).rotateLocal(x,y,z);
                        myWorld.prepareCanvas();
                        myWorld.generateImage();
                        myWorld.drawImage();
                        myWorld.finishCanvas();
                        iCount++;
                        if((iCount%50) == 0) {
                                lTime0-= System.currentTimeMillis();
                                lTime0 =-lTime0;
                                getAppletContext().showStatus((50000./lTime0)+" frames/second");
                                lTime0 = System.currentTimeMillis();
                        }
                }
        }

		public boolean mouseMove(Event evt, int x, int y) {
			myx += (x-oldx);
			myy += (y-oldy);
			oldx=x;
			oldy=y;
			myWorld.shiftPanoramicBackground(myx,myy);
			return true;
		}

}